c
c This program rewrite the compressed *.tar file with 3D fields
c generated by the model into the netcdf file.
c
c (C) 1999 Marat Khairoutdinov
c

	implicit none
	include 'netcdf.inc'

c---------------------------------------------------------------
c variables:

	character(200) filename
	character(80) long_name
	character(10) units
	character(8)  name
	character(1)  blank
	character(3) nm
        character(3) comp

	integer(2), allocatable :: byte(:,:,:)
        real(4), allocatable :: byte4(:,:,:)

	real(4), allocatable ::  fld(:,:,:),lats(:,:),lons(:,:)
	real(4) dx,dy,z(500),zi(500),p(500),x(100000),y(100000),time
        real(4) x1(100000),y1(100000),dz(500),rho(500),rhoi(500)
	real(4) f_min(500), f_max(500), ztype
        

	integer(4) nsubs,nsubsx,nsubsy,nx,ny,ny_max,nz,nfields
	integer(4) i,in,j,k,k1,k2,m,n,mn,i0,j0,nx_gl,ny_gl,count,ifields
        integer(4) nys(10000)

	integer(4) vdimids(4), start(4), ndimids
	integer(4) ncid,err,zid,ziid,yid,xid,timeid,varid

        logical(4) savebin,dolatlon

c External functions:

	integer(4) iargc,strlen1
	external iargc,strlen1

c---------------------------------------------------------------

c
c Read the file-name from the comman line:
c
	i=COMMAND_ARGUMENT_COUNT()
	if(i.eq.0) then
	  print*,'no input-file name is specified.'
	  print*,'Format: 3D2nc_sepfields_latlon input.3D'
	  stop
	end if
	call getarg(1,filename)
	print*,filename

c
c check file extension::

      do i=1,190
       if(filename(i:i+3).eq.'.3DC') then
         EXIT
       else if(i.eq.190) then
         print*,'wrong filename extension!'
         stop
       endif
      end do
      in = i

c---------------------------------------------------------------
c Read files; merge data from different subdomains;
c save as a netcdf file.
c
	open(1,file=trim(filename),status='old',form='unformatted',action='read')
	read(1) nx,ny_max,nz,nsubs,nsubsx,nsubsy,nfields
        print*,'nx,ny,nz,nsubs,nsubsx,nsubsy,nfields:',nx,ny_max,nz,nsubs,nsubsx,nsubsy,nfields
	print*,'nz=',nz
	read(1) dx, dy
	print*,'dx, dy:',dx,dy
	read(1) time
	print*,'time= ',time
        read(1) dolatlon
        print*,'latlon grid? ',dolatlon
        read(1) comp
        print*,'component: ',comp

	read(1) z(1:nz),p(1:nz),rho(1:nz),rhoi(1:nz),dz(1:nz)
	print*,'z:',z(1:nz)
	print*,'p:',p(1:nz)

        j=0
        i=0
        read(1) nys(1:nsubs)        
        allocate(lats(ny_max,nsubs),lons(nx,nsubs))
        read(1) lats,lons
        print*,minval(lats),maxval(lats)
        do n=1,nsubs
          ny = nys(n)
          y1(1:ny) = lats(1:ny,n) 
          if(mod(n-1,nsubsx).eq.0) then
            y(j+1:j+ny) = y1(1:ny)  
            j = j+ny
          end if
        end do
        nx_gl = nx*nsubsx
        print*,'nx_gl=',nx_gl
        do i=1,nsubsx*nx
         x(i) = lons(1,1)+(i-1)*(lons(2,1)-lons(1,1))
        end do
        ny_gl = j
        print*,'ny_gl=',ny_gl
        print*,'lat:',y(1:ny_gl)
        print*,'lat:',minval(y(1:ny_gl)),maxval(y(1:ny_gl))
        print*,'lon:',minval(x(1:nx_gl)),maxval(x(1:nx_gl))
	allocate (byte(nx,ny_max,nz))
	allocate (byte4(nx,ny_max,nz))
	allocate (fld(nx_gl,ny_gl,nz))

! interface height:
        zi(1)=0.
        do k=2,nz
         zi(k) = zi(k-1)+dz(k-1) 
        end do
c
c Initialize netcdf stuff, define variables,etc.
c
	err = NF_CREATE(filename(:in-1)//"."//comp//".3DC.nc", 
     &                  ior(nf_clobber,nf_64bit_offset), ncid)
	err = NF_REDEF(ncid)

	err = NF_DEF_DIM(ncid, 'lon', nx_gl, xid)
	if(ny_gl.ne.1)err = NF_DEF_DIM(ncid, 'lat', ny_gl, yid)
	err = NF_DEF_DIM(ncid, 'z', nz, zid)
	err = NF_DEF_DIM(ncid, 'zi', nz, ziid)
	err = NF_DEF_DIM(ncid, 'time', NF_UNLIMITED, timeid)

        if(dolatlon) then
          err = NF_DEF_VAR(ncid, 'lon', NF_FLOAT, 1, xid, varid)
	  err = NF_PUT_ATT_TEXT(ncid,varid,'units',12,'degrees east')
	  if(ny_gl.ne.1) then
           err = NF_DEF_VAR(ncid, 'lat', NF_FLOAT, 1, yid, varid)
	   err = NF_PUT_ATT_TEXT(ncid,varid,'units',13,'degrees north')
	  endif
        else
          err = NF_DEF_VAR(ncid, 'x', NF_FLOAT, 1, xid, varid)
	  err = NF_PUT_ATT_TEXT(ncid,varid,'units',1,'m')
	  if(ny_gl.ne.1) then
           err = NF_DEF_VAR(ncid, 'y', NF_FLOAT, 1, yid, varid)
	   err = NF_PUT_ATT_TEXT(ncid,varid,'units',1,'m')
	  endif
        end if
        err = NF_DEF_VAR(ncid, 'z', NF_FLOAT, 1, zid, varid)
	err = NF_PUT_ATT_TEXT(ncid,varid,'units',1,'m')
        err = NF_PUT_ATT_TEXT(ncid,varid,'long_name',6,'height')
        err = NF_DEF_VAR(ncid, 'zi', NF_FLOAT, 1, ziid, varid)
	err = NF_PUT_ATT_TEXT(ncid,varid,'units',1,'m')
        err = NF_PUT_ATT_TEXT(ncid,varid,'long_name',16,'interface height')
        err = NF_DEF_VAR(ncid, 'time', NF_FLOAT, 1, timeid, varid)
	err = NF_PUT_ATT_TEXT(ncid,varid,'units',3,'day')
        err = NF_PUT_ATT_TEXT(ncid,varid,'long_name',4,'time')
        err = NF_DEF_VAR(ncid, 'p', NF_FLOAT, 1, zid,varid)
	err = NF_PUT_ATT_TEXT(ncid,varid,'units',2,'mb')
        err = NF_PUT_ATT_TEXT(ncid,varid,'long_name',8,'pressure')
        err = NF_DEF_VAR(ncid, 'dz', NF_FLOAT, 1, zid,varid)
        err = NF_PUT_ATT_TEXT(ncid,varid,'units',1,'m')
        err = NF_PUT_ATT_TEXT(ncid,varid,'long_name',15,'layer thinkness')
        err = NF_DEF_VAR(ncid, 'rho', NF_FLOAT, 1, zid,varid)
        err = NF_PUT_ATT_TEXT(ncid,varid,'units',5,'kg/m3')
        err = NF_PUT_ATT_TEXT(ncid,varid,'long_name',7,'density')
        err = NF_DEF_VAR(ncid, 'rhoi', NF_FLOAT, 1, ziid,varid)
        err = NF_PUT_ATT_TEXT(ncid,varid,'units',5,'kg/m3')
        err = NF_PUT_ATT_TEXT(ncid,varid,'long_name',17,'interface density')
	err = NF_ENDDEF(ncid)

        if(dolatlon) then
	  err = NF_INQ_VARID(ncid,'lon',varid)
	  err = NF_PUT_VAR_REAL(ncid, varid, x)
	  if(ny_gl.ne.1) then
	  err = NF_INQ_VARID(ncid,'lat',varid)
	  err = NF_PUT_VAR_REAL(ncid, varid, y)
	  endif
        else
	  err = NF_INQ_VARID(ncid,'x',varid)
          do i=1,nx_gl
            x1(i) = (i-1)*dx
          end do
	  err = NF_PUT_VAR_REAL(ncid, varid, x1)
	  if(ny_gl.ne.1) then
	  err = NF_INQ_VARID(ncid,'y',varid)
	  err = NF_PUT_VAR_REAL(ncid, varid, y1)
	  endif
        end if

	err = NF_INQ_VARID(ncid,'z',varid)
	err = NF_PUT_VAR_REAL(ncid, varid, z)
	err = NF_INQ_VARID(ncid,'zi',varid)
	err = NF_PUT_VAR_REAL(ncid, varid, zi)
	err = NF_INQ_VARID(ncid,'time',varid)
	err = NF_PUT_VAR1_REAL(ncid, varid, 1, time)
	err = NF_INQ_VARID(ncid,'p',varid)
	err = NF_PUT_VAR_REAL(ncid, varid, p)
        err = NF_INQ_VARID(ncid,'dz',varid)
        err = NF_PUT_VAR_REAL(ncid, varid, dz)
        err = NF_INQ_VARID(ncid,'rho',varid)
        err = NF_PUT_VAR_REAL(ncid, varid, rho)
        err = NF_INQ_VARID(ncid,'rhoi',varid)
        err = NF_PUT_VAR_REAL(ncid, varid, rhoi)

	
        err = NF_REDEF(ncid)

      print*,'defining variables in netcdf:'

      ifields=0
      do while(ifields.lt.nfields)
        read(1) name,blank,long_name,blank,units
        print*,trim(name)//' '//trim(long_name)
        read(1) savebin,ztype
        print*,savebin,ztype
        if(.not.savebin) read(1) 
        do n=0,nsubs-1
          read(1)
        end do
	if(ny_gl.ne.1) then
	 ndimids=4
	 vdimids(1) = xid
	 vdimids(2) = yid
         if(ztype.eq.1) then
	   vdimids(3) = zid
         else
	   vdimids(3) = ziid
         end if
	 vdimids(4) = timeid
	else
	 ndimids=3
	 vdimids(1) = xid
         if(ztype.eq.1) then
	   vdimids(2) = zid
         else
	   vdimids(2) = ziid
         end if
	 vdimids(3) = timeid
	endif
        err = NF_DEF_VAR(ncid,name, NF_FLOAT, ndimids, vdimids, varid)
        err = NF_PUT_ATT_TEXT(ncid,varid,'long_name',
     &          strlen1(trim(long_name)),trim(long_name))
        err = NF_PUT_ATT_TEXT(ncid,varid,'units',
     &          strlen1(trim(units)),trim(units))
	ifields=ifields+1
      end do
         print*,'Done defining netcdf'
         err = NF_ENDDEF(ncid)
         rewind(1)
         read(1)
         read(1)
         read(1)
         read(1)
         read(1)
         read(1)
         read(1)
         read(1)


      ifields=0
      do while(ifields.lt.nfields)

	read(1) name,blank,long_name,blank,units
	print*, trim(name),blank,trim(long_name),blank,trim(units)
        read(1) savebin,ztype
        print*,'binary?',savebin
        if(.not.savebin) read(1) f_max(1:nz),f_min(1:nz)

        mn=0
        j0=0
	do n=0,nsubsy-1
         do m=0,nsubsx-1
	    mn = mn+1 
            ny = nys(mn)
            i0 = m*(nx_gl/nsubsx)
            if(savebin) then
     	      read(1) byte4(:,:,:)
	      count=0
	      do k=1,nz
	       do j=1,ny
	        do i=1,nx
                  count=count+1
                  fld(i0+i,j0+j,k)=byte4(i,j,k)
	        end do
	       end do
	      end do
            else
     	       read(1) byte(:,:,:)
	       count=0
	       do k=1,nz
	        do j=1,ny
	         do i=1,nx
		   fld(i0+i,j0+j,k)=f_min(k)+(byte(i,j,k)+32000.)*(f_max(k)-f_min(k))/64000.
	         end do
	        end do
	       end do
            end if

          end do
          j0=j0+ny
	end do ! n

	print*,minval(fld),maxval(fld)
	ifields=ifields+1

        err = NF_INQ_VARID(ncid,name,varid)
	err = NF_PUT_VAR_REAL(ncid, varid, fld)


      end do ! while

	err = NF_CLOSE(ncid)

      end
	




	integer function strlen1(str)
	character*(*) str
	strlen1=len(str)
	do i=1,len(str)
	  if(str(i:i).ne.' ') then
	    strlen1=strlen1-i+1
	    return
	  endif 
	end do
        return
	end
